EDIT - feature request #7993

Display "Access Denied" dialog in case the remoting service responds with status code = 4xx
01/14/2019 06:02 PM - Andreas Kohlbecker

Status: Closed Start date:

Priority: Highest Due date:

Assignee: Katja Luther % Done: 100%
Category: taxeditor Estimated time: 0:00 hour
Target version: Release 5.5

Severity: major

Description

May duplicate #8042

Now that #7972 is implemented a user lacking the role ROLE_REMOTING will not be able to use the Taxeditor.
On attempts to access the remoting webservice the taxeditor will receive HTTP response: status code = 403.

It makes sense to cover all status code = 4xx reponses in the same way namely to display a "Access Denied" dialog
instead of letting the exception be caught by the standard error dialog.

login : andreas
editor version : 5.5.0.201901141348
server : localhost (localhost-dev)
schema version : 5.0.0.0.20180514
os : Linux 4.15.0-43-generic amdé64
java : 1.8.0_131
org.eclipse.swt.SWTException: Failed to execute runnable (org.springframework.remoting.RemoteAcces
sException: Could not access HTTP invoker remote service at [http://localhost:8081/remoting/term.s
ervice]; nested exception is org.apache.http.NoHttpResponseException: Did not receive successful H
TTP response: status code = 403, status message = [Access is denied])

at org.eclipse.swt.SWT.error (SWT. java:4533)

at org.eclipse.swt.SWT.error (SWT. java:4448)

at org.eclipse.swt.widgets.Synchronizer.runAsyncMessages (Synchronizer.java:185)

at org.eclipse.swt.widgets.Display.runAsyncMessages (Display. java:4536)

at org.eclipse.swt.widgets.Display.readAndDispatch(Display.java:4154)

at org.eclipse.jface.operation.ModalContext$ModalContextThread.block (ModalContext. java:165)

at org.eclipse.jface.operation.ModalContext.run (ModalContext. java:369)

at org.eclipse.jface.dialogs.ProgressMonitorDialog.run (ProgressMonitorDialog.java:481)

at eu.etaxonomy.taxeditor.store.CdmStoreConnector.start (CdmStoreConnector.java:147)

at eu.etaxonomy.taxeditor.store.CdmStore.connect (CdmStore. java:261)

at eu.etaxonomy.taxeditor.store.CdmStore.connect (CdmStore. java:216)

at eu.etaxonomy.taxeditor.ui.dialog.RemotingLoginDialog$9$1l.run (RemotinglLoginDialog. java:520)

at org.eclipse.ui.internal.UILockListener.doPendingWork (UILockListener.java:162)

at org.eclipse.ui.internal.UISynchronizer$3.run(UISynchronizer. java:154)

at org.eclipse.swt.widgets.RunnableLock.run (RunnableLock. java:35)

at org.eclipse.swt.widgets.Synchronizer.runAsyncMessages (Synchronizer. java:182)

at org.eclipse.swt.widgets.Display.runAsyncMessages (Display.java:4536)

at org.eclipse.swt.widgets.Display.readAndDispatch (Display.java:4154)

at eu.etaxonomy.taxeditor.ui.dialog.RemotingLoginDialog.open (RemotingLoginDialog. java:212)

at eu.etaxonomy.taxeditor.handler.ed.ShowRemotingLoginWindowHandlerE4.execute (ShowRemotingLogi
nWindowHandlerE4. java:38)

at sun.reflect.NativeMethodAccessorImpl.invokeO (Native Method)

at sun.reflect.NativeMethodAccessorImpl.invoke (NativeMethodAccessorImpl. java:62)

at sun.reflect.DelegatingMethodAccessorImpl.invoke (DelegatingMethodAccessorImpl. java:43)

at java.lang.reflect.Method.invoke (Method. java:498)

at org.eclipse.ed.core.internal.di.MethodRequestor.execute (MethodRequestor.java:55)

at org.eclipse.e4d.core.internal.di.InjectorImpl.invokeUsingClass (InjectorImpl. java:282)

at org.eclipse.ed.core.internal.di.InjectorImpl.invoke (InjectorImpl.java:264)

at org.eclipse.ed.core.contexts.ContextInjectionFactory.invoke (ContextInjectionFactory. java:13

at org.eclipse.ed.core.commands.internal.HandlerServiceHandler.execute (HandlerServiceHandler. j

ava:152)
at org.eclipse.core.commands.Command.executeWithChecks (Command. java:494)
at org.eclipse.core.commands.ParameterizedCommand.executeWithChecks (ParameterizedCommand. java:
488)

at org.eclipse.ed.core.commands.internal.HandlerServiceImpl.executeHandler (HandlerServiceImpl.
java:210)

at org.eclipse.e4d.ui.workbench.renderers.swt.HandledContributionItem.executeltem (HandledContri
butionItem. java:433)

at org.eclipse.e4d.ui.workbench.renderers.swt.AbstractContributionItem.handleWidgetSelection (Ab
stractContributionItem. java:454)

at org.eclipse.ed.ui.workbench.renderers.swt.AbstractContributionItem$3.handleEvent (AbstractCo
ntributionItem. java:482)

at org.eclipse.swt.widgets.EventTable.sendEvent (EventTable. java:84)

at org.eclipse.swt.widgets.Display.sendEvent (Display.java:5227)

at org.eclipse.swt.widgets.Widget.sendEvent (Widget. java:1340)

at org.eclipse.swt.widgets.Display.runDeferredEvents (Display.java:4561)

at org.eclipse.swt.widgets.Display.readAndDispatch (Display.java:4151)

at org.eclipse.ed.ui.internal.workbench.swt.PartRenderingEngine$4.run (PartRenderingEngine. java
:1121)

at org.eclipse.core.databinding.observable.Realm.runWithDefault (Realm. java:336)

at org.eclipse.ed4.ui.internal.workbench.swt.PartRenderingEngine.run (PartRenderingEngine. java:1l
022)

at org.eclipse.e4d.ui.internal.workbench.E4Workbench.createAndRunUI (E4Workbench. java:150)

at org.eclipse.ui.internal.Workbench$5.run (Workbench. java:693)

at org.eclipse.core.databinding.observable.Realm.runWithDefault (Realm. java:336)

at org.eclipse.ui.internal.Workbench.createAndRunWorkbench (Workbench. java:610)

at org.eclipse.ui.PlatformUI.createAndRunWorkbench (PlatformUI. java:148)

at eu.etaxonomy.taxeditor.Application.start (Application. java:24)

at org.eclipse.equinox.internal.app.EclipseAppHandle.run (EclipseAppHandle. java:196)

at org.eclipse.core.runtime.internal.adaptor.EclipseAppLauncher.runApplication (EclipseAppLaunc
her.java:134)

at org.eclipse.core.runtime.internal.adaptor.EclipseAppLauncher.start (EclipseAppLauncher. java:
104)

at org.eclipse.core.runtime.adaptor.EclipseStarter.run(EclipseStarter.java:388)

at org.eclipse.core.runtime.adaptor.EclipseStarter.run(EclipseStarter.java:243)

at sun.reflect.NativeMethodAccessorImpl.invokeO (Native Method)

at sun.reflect.NativeMethodAccessorImpl.invoke (NativeMethodAccessorImpl. java:62)

at sun.reflect.DelegatingMethodAccessorImpl.invoke (DelegatingMethodAccessorImpl. java:43)

at java.lang.reflect.Method.invoke (Method. java:498)

at org.eclipse.equinox.launcher.Main.invokeFramework (Main. java:673)

at org.eclipse.equinox.launcher.Main.basicRun (Main. java:610)

at org.eclipse.equinox.launcher.Main.run (Main.java:1519)

at org.eclipse.equinox.launcher.Main.main (Main. java:1492)
Caused by: org.springframework.remoting.RemoteAccessException: Could not access HTTP invoker remot
e service at [http://localhost:8081/remoting/term.service]; nested exception is org.apache.http.No
HttpResponseException: Did not receive successful HTTP response: status code = 403, status message
= [Access 1s denied]

at org.springframework.remoting.httpinvoker.HttpInvokerClientInterceptor.convertHttpInvokerAcc
essException (HttpInvokerClientInterceptor. java:216)

at org.springframework.remoting.httpinvoker.HttpInvokerClientInterceptor.invoke (HttpInvokerCli
entInterceptor. java:147)

at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed (ReflectiveMethodInvoca
tion.java:179)

at org.springframework.aop.framework.JdkDynamicAopProxy.invoke (JdkDynamicAopProxy.java:208)

at com.sun.proxy.S$Proxy26.findWithoutFlush (Unknown Source)

at eu.etaxonomy.cdm.api.cache.CdmServiceCacher.findByUuid (CdmServiceCacher. java:93)

at eu.etaxonomy.cdm.api.cache.CdmCacher.load (CdmCacher. java:134)

at eu.etaxonomy.cdm.model.common.DefinedTermBase.getTermByClassAndUUID_aroundBody20 (DefinedTer
mBase. java:540)

at eu.etaxonomy.cdm.model.common.DefinedTermBase.getTermByClassAndUUID (DefinedTermBase. java:1l)

at eu.etaxonomy.cdm.model.name.Rank.getTermByUuid (Rank.java:230)

at eu.etaxonomy.cdm.model.name.Rank.initDefaultTerms_aroundBodyl74 (Rank.java:1016)

at eu.etaxonomy.cdm.model.name.Rank.initDefaultTerms (Rank.java:1)

at eu.etaxonomy.taxeditor.store.CdmStoreConnector$1$2.run (CdmStoreConnector. java:210)

at org.eclipse.swt.widgets.RunnableLock.run (RunnableLock. java:35)

at org.eclipse.swt.widgets.Synchronizer.runAsyncMessages (Synchronizer.java:182)

. 59 more
Caused by: org.apache.http.NoHttpResponseException: Did not receive successful HTTP response: stat
us code = 403, status message = [Access is denied]
at org.springframework.remoting.httpinvoker.HttpComponentsHttpInvokerRequestExecutor.validateR
esponse (HttpComponentsHttpInvokerRequestExecutor. java:357)

at org.springframework.remoting.httpinvoker.HttpComponentsHttpInvokerRequestExecutor.doExecute
Request (HttpComponentsHttpInvokerRequestExecutor. java:230)

at eu.etaxonomy.taxeditor.service.CdmServiceRequestExecutor.doExecuteRequest (CdmServiceRequest
Executor. java:61)

at org.springframework.remoting.httpinvoker.AbstractHttpInvokerRequestExecutor.executeRequest (
AbstractHttpInvokerRequestExecutor. java:138)

at org.springframework.remoting.httpinvoker.HttpInvokerClientInterceptor.executeRequest (HttpIn
vokerClientInterceptor. java:194)

at org.springframework.remoting.httpinvoker.HttpInvokerClientInterceptor.executeRequest (HttpIn
vokerClientInterceptor.java:176)

at org.springframework.remoting.httpinvoker.HttpInvokerClientInterceptor.invoke (HttpInvokerCli
entInterceptor. java:144)

72 more

Related issues:
Related to EDIT - bug #8042: Ul is too restricted for users with right Projec... Closed
Follows EDIT - feature request #7972: explicitly allow disallow access to HTT... Resolved

Associated revisions

Revision 6¢58d852 - 01/23/2019 01:30 PM - Katja Luther

ref #7993: handle exception when user has no role remoting

Revision 54b2bd04 - 01/29/2019 11:55 AM - Katja Luther

ref #7993: missed to commit some changes to catch 403 Exceptiojn

Revision 85¢7f77c - 01/31/2019 01:11 PM - Katja Luther

ref #7993: show better dialog when access denied and adapt RemoteCdmSource.toString

Revision dee24241 - 01/31/2019 04:08 PM - Katja Luther

ref #7993: change message size of message part

Revision c1ae46ed - 02/05/2019 09:35 AM - Katja Luther

fix #7993: close views when switching user and reopen them when user is authenticated

History

#1 - 01/14/2019 06:02 PM - Andreas Kohlbecker
- Due date set to 01/10/2019
- Start date changed from 01/14/2019 to 01/10/2019

- Follows feature request #7972: explicitly allow disallow access to HTTP Invoker endpoints (/remoting/**) added

#2 - 01/14/2019 07:28 PM - Andreas Miiller
- Due date deleted (01/10/2019)

- Assignee changed from Andreas Muiller to Katja Luther

#3 - 01/16/2019 01:57 PM - Andreas Miiller
- Priority changed from New to Highest

- Severity changed from normal to major

This is urgent and should definetely be done in 5.5

#4 - 01/16/2019 02:02 PM - Andreas Miuller

By the way, currently the login is successful but only then the exception is thrown | guess because | do not have admin rights anymore after the login
(I changed from admin to a user without ROLE_REMOTING rights). Also the Admin menu was removed.

So | think the ROLE_REMOTING rights should already be checked during authentication and authentication should not be successful if the role is not
available.
#5 - 01/16/2019 02:32 PM - Andreas Kohlbecker

How should this be possible?

Successful authentication is the required step for having a "user" in the security context. Otherwise the authentication can not be tested for a
GrantedAuthority. We do in fact not test for the role ROLE_REMOTING directly. All this done by Spring Security.

Well, the behavior of Spring Security can be changed if needed, but why should we?

#6 - 01/16/2019 02:37 PM - Andreas Kohlbecker

So | think the ROLE_REMOTING rights should already be checked during authentication and authentication should not be successful if the role
is not available.

Do you suggest to check the role from within the Taxeditor? If you do this, you make assumptions on the webservice security configuration which
might be correct by now, but what if the security configuration changes, are you shure that the role ROLE_REMOTIN will be the only criterion in
future.

To do this correctly you would need to interpret the security configuration:

.anonymous () .disable ()
.antMatcher ("/remoting/**")
.authorizeRequests () .anyRequest () .access ("hasAnyRole ('ROLE_ADMIN', 'ROLE_REMOTING')")
.and ()
.csrf () .disable()
.httpBasic();

#7 - 01/16/2019 02:53 PM - Andreas Miuiller

| do not really care about technical details of the implementation. There are multiple possiblities. E.g. we could add a second authentication method to
service layer authenticateAndCheckRemotingRights(username, ...) or something similar which first checks if the given username has the remoting
rights at all and then authenticates. | can't imagine that this is not possible.

Maybe it is also possible to revert to the old authentification if after authentification checking for ROLE_REMOTING (or ROLE_ADMIN) was not
successful. As | am not so deep into authentification details | don't know if this is possible.

| only wanted to say that the current implementation is not intuitive and very unexpected behaviour. If | try to login into something where | have
absolutely no rights | wouldn't expect that the login is still successful but | would expect that | end up with the state | am in before login.

#8 - 01/16/2019 02:56 PM - Andreas Miuller

Andreas Kohlbecker wrote:

, but what if the security configuration changes, are you sure that the role ROLE_REMOTIN will be the only criterion in future.

More or less, yes. Why should there be another role which is absolutely required to allow ANY access to the remoting services. But if there will be
another criterion, we have to add it.

#9 - 01/16/2019 03:03 PM - Andreas Kohlbecker

If | try to login into something where | have absolutely no rights | wouldn't expect that the login is still successful
That exactly is the point here. After logging in the server you have access to a couple of webservices, but the access to /remoting/** is denied. You
still can use the REST api, etc. This is only irritating from the taxeditor from the view on the whole platform this is 100% ok.

| think the editor should catch the exception and display a message and that's all. The usecase that a user is switching from 'Admin' to an
unpriviledges user is quite rare and special. Well, and if this happens to you, you need to login again as 'Admin’

| actually don't see the problem here.

#10 - 01/17/2019 09:39 AM - Andreas Miiller

Andreas Kohlbecker wrote:

If | try to login into something where | have absolutely no rights | wouldn't expect that the login is still successful

That exactly is the point here. After logging in the server you have access to a couple of webservices, but the access to /remoting/** is denied.
You still can use the REST api, etc. This is only irritating from the taxeditor from the view on the whole platform this is 100% ok.
We are only talking about the TaxEditor perspective here. Sure for other applications this discussion is different/not relevant.
| think the editor should catch the exception and display a message and that's all. The usecase that a user is switching from 'Admin' to an

unpriviledges user is quite rare and special. Well, and if this happens to you, you need to login again as 'Admin’'

| agree that the usecase is rare (except for testing/debugging) therefore we may implement a simpler solution if the proposed solution is difficult to
implement.

So what about a dialog saying that login was successful but no rights exist for the given user to use the TaxEditor. Therefore the user has been
logged off again. Please relogin with suffient rights. At the same time the TaxEditor automatically logsoff and reopens the login dialog. This should be
easy to implement and easy to understand for the user.

#11-01/17/2019 11:29 AM - Andreas Kohlbecker

So what about a dialog saying that login was successful but no rights exist for the given user to use the TaxEditor.

100% agreed!!!! BTW, this suggestion exactly matches the ticket description ;-) except of the fact that the message presented by the dialog should
rather be "You are logged in now but you are not permitted to use the TaxEditor with the data source ${dataSourceName}" instead of a harsh "Access
Denied"

The LoginDialog could perform a simple check by attempting to use a service method. The Exception can easily catched in this situation and the
LogniDialog can be kept open, so that the user can change the data source or the user account without needing to go into the menu again.

#12 - 01/23/2019 01:37 PM - Katja Luther
- Status changed from New to Resolved

- Assignee changed from Katja Luther to Andreas Mdiller

Now the login dialog is showing up again with a message that the user is logged in but has no rights to see the data with the taxeditor.
The message is shown only partly but the whole messsage is shown in a mouseover text.

please review. (for example with user2 in rem_conf_am and password test123)

#13 - 01/25/2019 01:49 PM - Andreas Miiller

- Description updated

#14 - 01/25/2019 01:54 PM - Andreas Miiller
- File picture061-1.png added

| still get a not nice looking dialog when loging in with no rights:

04/18/2024 5/10



Progress Information

Ceonnecting to Remote COM Instance edit-test:80/cdmserver/rem_conf_am

Benutzer authentifizieren

Cancel

ED Remate Access Error —|= -

‘-.I Maybe the server is currently not available. If the problem persists please contact the
‘S’ server admin with the error trace below.

org.eclipse.swt. SWTException: Failed to execute runnable
(org.springframework.remeting. RemoteAccessException: Could not access HTTP
invoker remote service at
[http://test.e-taxonomy.ew:80/cdmserver/rem_conf_am/remoting/term.service];
nested exception is org.apache.http.MoHttpResponseException: Did not receive
successful HTTP response: status code = 403, status message = [Access is denied])

Copy Error || oK || Details ==

login : norights
editor version : 5.5.0.201901242349
server : test.e-taxonomy.eu (edit-test) / rem_conf_am
schema version : 5.0.0.0.20180514
os : Windows Server 2012 R2 6.3 amd64
java : 1.8.0_121
org.eclipse.swt.SWIException: Failed to execute runnable (org.springframework.remoting.RemoteAccessException:
Could not access HTTP invoker remote service at [http://test.e-taxonomy.eu:80/cdmserver/rem_conf_am/remoting/t
erm.service]; nested exception is org.apache.http.NoHttpResponseException: Did not receive successful HTTP res
ponse: status code = 403, status message = [Access is denied])
at org.eclipse.swt.SWT.error (SWT. java:4533)
at org.eclipse.swt.SWT.error (SWT. java:4448)
at org.eclipse.swt.widgets.Synchronizer.runAsyncMessages (Synchronizer. java:185)
at org.eclipse.swt.widgets.Display.runAsyncMessages (Display.java:4211)
at org.eclipse.swt.widgets.Display.readAndDispatch (Display.java:3827)
at org.eclipse.jface.operation.ModalContext$ModalContextThread.block (ModalContext.java:165)
at org.eclipse.jface.operation.ModalContext.run (ModalContext.java:369)
at org.eclipse.jface.dialogs.ProgressMonitorDialog.run (ProgressMonitorDialog. java:481)
at eu.etaxonomy.taxeditor.store.CdmStoreConnector.start (CdmStoreConnector.java:147)
at eu.etaxonomy.taxeditor.store.CdmStore.connect (CdmStore. java:261)
at eu.etaxonomy.taxeditor.store.CdmStore.connect (CdmStore. java:216)
at eu.etaxonomy.taxeditor.ui.dialog.RemotingLoginDialog.connect (RemotingLoginDialog. java:908)
at eu.etaxonomy.taxeditor.ui.dialog.RemotingLoginDialog.connectButtonPressed (RemotinglLoginDialog. java:486)
at eu.etaxonomy.taxeditor.ui.dialog.RemotingLoginDialog.access$2 (RemotingLoginDialog. java:482)
at eu.etaxonomy.taxeditor.ui.dialog.RemotingLoginDialog$6.widgetSelected (RemotingLoginDialog. java:365)
at org.eclipse.swt.widgets.TypedListener.handleEvent (TypedListener. java:249)
at org.eclipse.swt.widgets.EventTable.sendEvent (EventTable. java:84)
at org.eclipse.swt.widgets.Display.sendEvent (Display.java:4418)
at org.eclipse.swt.widgets.Widget.sendEvent (Widget. java:1079)
at org.eclipse.swt.widgets.Display.runDeferredEvents (Display.java:4236)
at org.eclipse.swt.widgets.Display.readAndDispatch (Display.java:3824)
at eu.etaxonomy.taxeditor.ui.dialog.RemotingLoginDialog.open (RemotingLoginDialog. java:214)
at eu.etaxonomy.taxeditor.ui.dialog.RemotingLoginDialog.open (RemotingLoginDialog. java:189)
at eu.etaxonomy.taxeditor.ui.dialog.RemotingLoginDialog.open (RemotingLoginDialog. java:180)
at eu.etaxonomy.taxeditor.handler.e4d.SwitchUserHandlerE4.execute (SwitchUserHandlerE4. java:37)
at sun.reflect.NativeMethodAccessorImpl.invokeO (Native Method)
at sun.reflect.NativeMethodAccessorImpl.invoke (NativeMethodAccessorImpl. java:62)
at sun.reflect.DelegatingMethodAccessorImpl.invoke (DelegatingMethodAccessorImpl. java:43)
at java.lang.reflect.Method.invoke (Method. java:498)
at org.eclipse.ed.core.internal.di.MethodRequestor.execute (MethodRequestor. java:55)
at org.eclipse.ed.core.internal.di.InjectorImpl.invokeUsingClass (InjectorImpl. java:282)
at org.eclipse.e4.core.internal.di.InjectorImpl.invoke (InjectorImpl. java:264)
at org.eclipse.ed.core.contexts.ContextInjectionFactory.invoke (ContextInjectionFactory.java:132)
at org.eclipse.e4.core.commands.internal.HandlerServiceHandler.execute (HandlerServiceHandler. java:152)
at org.eclipse.core.commands.Command.executeWithChecks (Command. java:494)
at org.eclipse.core.commands.ParameterizedCommand.executeWithChecks (ParameterizedCommand. java:488)
at org.eclipse.ed.core.commands.internal.HandlerServiceImpl.executeHandler (HandlerServiceImpl. java:210)

at org.eclipse.e4d.ui.workbench.renderers.swt.HandledContributionItem.executeltem (HandledContributionItem. j
ava:433)

at org.eclipse.ed.ui.workbench.renderers.swt.AbstractContributionItem.handleWidgetSelection (AbstractContri
butionItem. java:454)

at org.eclipse.e4.ui.workbench.renderers.swt.AbstractContributionItem$3.handleEvent (AbstractContributionIt
em. java:482)

at org.eclipse.swt.widgets.EventTable.sendEvent (EventTable. java:84)

at org.eclipse.swt.widgets.Display.sendEvent (Display.java:4418)

at org.eclipse.swt.widgets.Widget.sendEvent (Widget.java:1079)

at org.eclipse.swt.widgets.Display.runDeferredEvents (Display.java:4236)

at org.eclipse.swt.widgets.Display.readAndDispatch (Display.java:3824)

at org.eclipse.e4.ui.internal.workbench.swt.PartRenderingEngine$4.run (PartRenderingEngine. java:1121)

at org.eclipse.core.databinding.observable.Realm.runWithDefault (Realm. java:336)

at org.eclipse.e4.ui.internal.workbench.swt.PartRenderingEngine.run (PartRenderingEngine.java:1022)

at org.eclipse.e4d.ui.internal.workbench.E4Workbench.createAndRunUI (E4Workbench. java:150)

at org.eclipse.ui.internal.Workbench$5.run (Workbench. java:693)

at org.eclipse.core.databinding.observable.Realm.runWithDefault (Realm. java:336)

at org.eclipse.ui.internal.Workbench.createAndRunWorkbench (Workbench. java:610)

at org.eclipse.ui.PlatformUI.createAndRunWorkbench (PlatformUI. java:148)

at eu.etaxonomy.taxeditor.Application.start (Application.java:24)

at org.eclipse.equinox.internal.app.EclipseAppHandle.run (EclipseAppHandle. java:196)

at org.eclipse.core.runtime.internal.adaptor.EclipseAppLauncher.runApplication (EclipseAppLauncher. java:134

at org.eclipse.core.runtime.internal.adaptor.EclipseAppLauncher.start (EclipseAppLauncher.java:104)

at org.eclipse.core.runtime.adaptor.EclipseStarter.run (EclipseStarter. java:388)

at org.eclipse.core.runtime.adaptor.EclipseStarter.run(EclipseStarter.java:243)

at sun.reflect.NativeMethodAccessorImpl.invokeO (Native Method)

at sun.reflect.NativeMethodAccessorImpl.invoke (NativeMethodAccessorImpl. java:62)

at sun.reflect.DelegatingMethodAccessorImpl.invoke (DelegatingMethodAccessorImpl. java:43)

at java.lang.reflect.Method.invoke (Method. java:498)

at org.eclipse.equinox.launcher.Main.invokeFramework (Main. java:673)

at org.eclipse.equinox.launcher.Main.basicRun (Main. java:610)

at org.eclipse.equinox.launcher.Main.run (Main.java:1519)
Caused by: org.springframework.remoting.RemoteAccessException: Could not access HTTP invoker remote service at

[http://test.e-taxonomy.eu:80/cdmserver/rem_conf_am/remoting/term.service]; nested exception is org.apache.ht

tp.NoHttpResponseException: Did not receive successful HTTP response: status code = 403, status message = [Acc
ess is denied]

at org.springframework.remoting.httpinvoker.HttpInvokerClientInterceptor.convertHttpInvokerAccessException
(HttpInvokerClientInterceptor. java:216)

at org.springframework.remoting.httpinvoker.HttpInvokerClientInterceptor.invoke (HttpInvokerClientIntercept
or.java:147)

at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed (ReflectiveMethodInvocation. java:17
9)

at org.springframework.aop.framework.JdkDynamicAopProxy.invoke (JdkDynamicAopProxy.java:208)

at com.sun.proxy.S$Proxy46.findWithoutFlush (Unknown Source)

at eu.etaxonomy.cdm.api.cache.CdmServiceCacher.findByUuid (CdmServiceCacher. java:93)

at eu.etaxonomy.cdm.api.cache.CdmCacher.load (CdmCacher. java:134)

at eu.etaxonomy.cdm.model.common.DefinedTermBase.getTermByClassAndUUID_aroundBody20 (DefinedTermBase. java:5
40)

at eu.etaxonomy.cdm.model.common.DefinedTermBase.getTermByClassAndUUID (DefinedTermBase. java:1l)

at eu.etaxonomy.cdm.model.name.Rank.getTermByUuid (Rank. java:230)

at eu.etaxonomy.cdm.model.name.Rank.initDefaultTerms_aroundBodyl74 (Rank.java:1016)

at eu.etaxonomy.cdm.model.name.Rank.initDefaultTerms (Rank.java:1l)

at eu.etaxonomy.taxeditor.store.CdmStoreConnectors$1$2.run(CdmStoreConnector. java:211)

at org.eclipse.swt.widgets.RunnableLock.run (RunnableLock. java:35)

at org.eclipse.swt.widgets.Synchronizer.runAsyncMessages (Synchronizer.java:182)

... 63 more
Caused by: org.apache.http.NoHttpResponseException: Did not receive successful HTTP response: status code = 40
3, status message = [Access 1s denied]

at org.springframework.remoting.httpinvoker.HttpComponentsHttpInvokerRequestExecutor.validateResponse (Http
ComponentsHttpInvokerRequestExecutor. java:357)

at org.springframework.remoting.httpinvoker.HttpComponentsHttpInvokerRequestExecutor.doExecuteRequest (Http
ComponentsHttpInvokerRequestExecutor. java:230)

at eu.etaxonomy.taxeditor.service.CdmServiceRequestExecutor.doExecuteRequest (CdmServiceRequestExecutor. jav
a:6l)

at org.springframework.remoting.httpinvoker.AbstractHttpInvokerRequestExecutor.executeRequest (AbstractHttp
InvokerRequestExecutor. java:138)

at org.springframework.remoting.httpinvoker.HttpInvokerClientInterceptor.executeRequest (HttpInvokerClientI
nterceptor. java:194)

at org.springframework.remoting.httpinvoker.HttpInvokerClientInterceptor.executeRequest (HttpInvokerClientI
nterceptor.java:176)

at org.springframework.remoting.httpinvoker.HttpInvokerClientInterceptor.invoke (HttpInvokerClientIntercept
or.java:144)

76 more
#15 - 01/25/2019 01:56 PM - Andreas Miiller

- File picture554-1.png added

- Status changed from Resolved to Feedback

- Assignee changed from Andreas Miiller to Katja Luther
But the login itself seems to work:

-Angemeldet als: nori: =

User is "norights”

#16 - 01/29/2019 12:15 PM - Katja Luther
- Status changed from Feedback to Resolved

- Assignee changed from Katja Luther to Andreas Miiller
sorry | missed to commit some of the changes. please review.

#17 - 01/29/2019 05:43 PM - Andreas Miiller
- Status changed from Resolved to Feedback

- Assignee changed from Andreas Miiller to Katja Luther
| still get the same error. Can you please test yourself on nightly.

#18 - 01/29/2019 05:56 PM - Andreas Miiller
| tested a bit further. It looks like feature works if nothing is opened yet before swithing user.
| tested with 1 taxon open and user bulkeditor open => exception (I switched in rem_conf_am) from admin to norights

#19 - 01/29/2019 05:57 PM - Andreas Miiller

Also the message is too long for the message text field. We should change the layout or shorten the message.

#20 - 01/31/2019 10:22 AM - Katja Luther

Andreas Muller wrote:

Also the message is too long for the message text field. We should change the layout or shorten the message.

You get the whole message as tooltip. But we also can shorten the message

#21 - 01/31/2019 10:25 AM - Andreas Miiller

Katja Luther wrote:
Andreas Muller wrote:

Also the message is too long for the message text field. We should change the layout or shorten the message.
You get the whole message as tooltip. But we also can shorten the message

Such a message should definetly not be truncated. However we could keep a longer message as tooltip to explain a bit more what happened. In
future theses tooltips should go into a helpsystem with a help button beside the message.

#22 - 01/31/2019 11:03 AM - Patrick Plitzner
- Related to bug #8042: Ul is too restricted for users with right Project Manager added

#23 - 01/31/2019 11:03 AM - Patrick Plitzner

- Description updated

#24 - 01/31/2019 11:04 AM - Patrick Plitzner

- Description updated
#25 - 01/31/2019 01:10 PM - Andreas Kohlbecker

From the report which can be found in #8042 it seems obvious that it is still possible to use the Editor after a successful login with a user which lacks
the authority to use the remoting service. A user without permission to use the removing service should not be able to do anything related to data in
the editor.

By now is see the following options

1. once the login dialog knows the user is not permitted to use the remoting service, it should automatically logout the user. The message displayed
to the user needs to be different in this case. "Your credentials are valid but you are not permitted access any data." ... something more compact
of course

2. The login dialog will log out the user once the dialog is closed.

#26 - 01/31/2019 03:55 PM - Andreas Miiller
Andreas Kohlbecker wrote:
From the report which can be found in #8042 it seems obvious that it is still possible to use the Editor after a successful login with a user which

lacks the authority to use the remoting service. A user without permission to use the removing service should not be able to do anything related
to data in the editor.

By now is see the following options

1. once the login dialog knows the user is not permitted to use the remoting service, it should automatically logout the user. The message
displayed to the user needs to be different in this case. "Your credentials are valid but you are not permitted access any data." ... something
more compact of course

2. The login dialog will log out the user once the dialog is closed.

| don't think the report your conclusion is correct. If it were it means that the complete remoting role does not work correctly, which is handled in
#7972. | think you misunderstood why there is data to see. | guess the reporter did change login so there was still "old data" visible (which is not really
correct, all views should be emptied when changing user, but it is not critical). | tried to login as first user with no rights and | did not get any data.

#27 - 01/31/2019 04:10 PM - Katja Luther
- Status changed from Feedback to Resolved

- Assignee changed from Katja Luther to Andreas Mdiller

the message is adapted and the message part of the login dialog is larger, now.

cleaning all views when changing the user | move to a new ticket.

#28 - 02/01/2019 01:24 PM - Andreas Miiller

- File picture875-1.png added

- Status changed from Resolved to Feedback

- Assignee changed from Andreas Muiller to Katja Luther

- % Done changed from 0 to 90

Seems to work now as expected except for the non emptied views. Can you please link to the new ticket and then close this ticket.

Logout as suggested in #7993#note-25 is not needed IMO. When ever | try to access data | get the message

3 Access denied -

I.o.l The connection to the server could not be esablished because the access was denied.

which is ok. Also in theory data can not be available as all data access in TaxEditor works through httplnvoker which is secured.

#29 - 02/04/2019 01:59 PM - Katja Luther
- Status changed from Feedback to Closed
- % Done changed from 90 to 100

#30 - 02/04/2019 02:13 PM - Andreas Miiller
https://dev.e-taxonomy.eu/redmine/issues/8042
https://dev.e-taxonomy.eu/redmine/issues/8042
https://dev.e-taxonomy.eu/redmine/issues/7972
https://dev.e-taxonomy.eu/redmine/issues/7993#note-25

Andreas Muller wrote:

Seems to work now as expected except for the non emptied views. Can you please link to the new ticket and then close this ticket.

I think the link is still missing.

#31 - 02/05/2019 09:43 AM - Katja Luther

the closing of views is implemted now (see last commit). so we do not need a new ticket and close this one

Files

picture061-1.png 20.6 KB 01/25/2019 Andreas Miller
picture554-1.png 1.03 KB 01/25/2019 Andreas Miller
picture875-1.png 6.39 KB 02/01/2019 Andreas Miller
